//***************************************************************************
// Ces applets viennent en complment du livre :
//
//  		VIE ARTIFICIELLE
//      O la biologie rencontre l'informatique
//		Illustr en Java
//            Jean-Philippe Rennard
//           	  Vuibert 2002
//===========================================================================
//  L-systmes
//    v:0.1 09/09/2002
//
//  Cette applet permet de construire des L-systmes.
//
//    Jean-Philippe Rennard 2001-2002
//
//    This program is free software; you can redistribute it and/or
//    modify it under the terms of the GNU General Public License
//    as published by the Free Software Foundation.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//***************************************************************************
package lsys;

import java.awt.*;
import vabase.*;

/** Gestion graphique du L-systme */
public class vueLsys extends Cvue {
  /** Pointeur sur le L-systme */
  private Clsys lsPere;
  /** Table des couleurs */
  private Color couleur[];

  /** Constructeur par dfaut */
  public vueLsys(Clsys ls) {
    super(Color.white, Color.black, Cvue.REPRANISOTROPIC);
    lsPere=ls;
    setCouleur();
  }
  /** Constructeur avec fond */
  public vueLsys(Clsys ls, Color c, Color f) {
    super(c, f, Cvue.REPRANISOTROPIC);
    lsPere=ls;
    setCouleur();
  }
  /** Fixe nouvelle taille */
  public void setNewTaille() {
    redimGrBuff();
    repaint();
  }
  /** Affichage */
  public void affiche(Cnoeud n, float x2, float y2) {
    grBuff.setColor(getCouleur(n.colCrt));
    grBuff.drawLine(lToRX(n.posX),lToRY(lHauteur-n.posY),
                              lToRX(x2), lToRY(lHauteur-y2));
  }
  /** Renvoie un numro de couleur */
  Color getCouleur(int c) {
    return couleur[c%7];
  }
  /** Init table couleurs */
  private void setCouleur() {
    couleur=new Color[7];
    couleur[0]=Color.white;
    couleur[1]=Color.green;
    couleur[2]=Color.orange;
    couleur[3]=Color.yellow;
    couleur[4]=Color.pink;
    couleur[5]=Color.magenta;
    couleur[6]=Color.red;
  }
}